///////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2010 Sebastian Pancratz                                     //
//                                                                           //
// Distributed under the terms of the GNU General Public License as          //
// published by the Free Software Foundation; either version 2 of the        //
// License, or (at your option) any later version.                           //
//                                                                           //
// http://www.gnu.org/licenses/                                              //
///////////////////////////////////////////////////////////////////////////////

#ifndef _FMPQ_POLY_TESTR_H_
#define _FMPQ_POLY_TESTR_H_

#ifdef __cplusplus
    extern "C" {
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <time.h>
#include <gmp.h>

#include "flint.h"
#include "mpz_poly.h"
#include "fmpz_poly.h"
#include "fmpq_poly.h"

/**
 * \file     fmpq_poly-testr.h
 * \brief    Randomisation functionality as the basis for testing
 * \author   Sebastian Pancratz
 * \date     July 2010
 * \version  0.1.7
 */

ulong SEED_GMP = 123456789ul;

ulong SEED_SYS = 123456789ul;

void fmpz_randtest(fmpz_t * f, gmp_randstate_t R, ulong bits);

void fmpz_randtest_not_zero(fmpz_t * f, gmp_randstate_t R, ulong bits);

void fmpz_poly_randtest(fmpz_poly_t poly, 
                                     gmp_randstate_t R, ulong len, ulong bits);

void fmpz_poly_randtest_not_zero(fmpz_poly_t poly, 
                                     gmp_randstate_t R, ulong len, ulong bits);

void fmpq_poly_randtest(fmpq_poly_t poly, 
                                     gmp_randstate_t R, ulong len, ulong bits);

void fmpq_poly_randtest_not_zero(fmpq_poly_t poly, 
                                     gmp_randstate_t R, ulong len, ulong bits);

#ifdef __cplusplus
    }
#endif

#endif

